<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="批次号" prop="batchNo">
        <el-input
          v-model="queryParams.batchNo"
          placeholder="请输入批次号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="快递公司" prop="express">
        <el-input
          v-model="queryParams.express"
          placeholder="请输入快递公司"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="快递员" prop="username">
        <el-input
          v-model="queryParams.username"
          placeholder="请输入快递员"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="运单号" prop="expressNo">
        <el-input
          v-model="queryParams.expressNo"
          placeholder="请输入运单号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		  :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="logisticsList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="批次号" align="center" prop="batchNo" />
      <el-table-column label="快递公司" align="center" prop="express" />
      <el-table-column label="快递员" align="center" prop="username" />
      <el-table-column label="快递员电话" align="center" prop="tel" />
      <el-table-column label="运单号" align="center" prop="expressNo" />
      <el-table-column label="发货照片" align="center" prop="imgUrl">
        <template slot-scope="scope">
          <el-image
            v-if="scope.row.imgUrl"
            :src="scope.row.imgUrl"
            :preview-src-list="[scope.row.imgUrl]"
            :z-index="9999"
            style="width: 30px;height: 30px;"
          ></el-image>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="创建人" align="center" prop="createBy" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-document"
            @click="handleDetail(scope.row)"
          >详情</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改出货物流对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body destroy-on-close :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-row class="el-row-table">
          <el-col :span="12">
            <el-form-item label="批次号" prop="inspectId">
              <el-select
                style="width:100%"
                v-model="form.inspectId"
                placeholder="请选择批次号"
                clearable size="small"
              >
                <el-option
                  v-for="execute in executeData"
                  :key="execute.id"
                  :label="execute.batchNo"
                  :value="execute.id"
                />
              </el-select>
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="快递公司" prop="express">
              <el-input v-model="form.express" placeholder="请输入快递公司" />
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="快递员" prop="username">
              <el-input v-model="form.username" placeholder="请输入快递员" />
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="快递员电话" prop="tel">
              <el-input v-model="form.tel" placeholder="请输入快递员电话" />
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="运单号" prop="expressNo">
              <el-input v-model="form.expressNo" placeholder="请输入运单号" />
            </el-form-item>
          </el-col>

          <el-col :span="24">
            <el-form-item label="发货照片">
              <imageUpload v-model="form.imgUrl"/>
            </el-form-item>
          </el-col>
        </el-row>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 详情 -->
    <DetailInfo ref="detail"/>

  </div>
</template>

<script>
import { listLogistics, getLogistics, delLogistics, addLogistics, updateLogistics, exportLogistics } from "@/api/track/logistics";
import ImageUpload from '@/components/ImageUpload';
import { executeInfoList } from "@/api/track/execute";
import DetailInfo from "./components/DetailInfo";
export default {
  name: "Logistics",
  components: {
    ImageUpload,
    DetailInfo
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 出货物流表格数据
      logisticsList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        inspectId: null,
        express: null,
        username: null,
        expressNo: null,
        batchNo: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        inspectId: [
          { required: true, message: "执行编号不能为空", trigger: "change" }
        ],
        express: [
          { required: true, message: "快递公司不能为空", trigger: "blur" }
        ],
        username: [
          { required: true, message: "快递员不能为空", trigger: "blur" }
        ],
        tel: [
          { required: true, message: "快递员电话不能为空", trigger: "blur" },
          {
            type: 'number',
            message: '手机号格式不正确',
            trigger: 'blur',
            transform(value) {
              let phonereg = 11 && /^((13|14|15|16|17|18|19)[0-9]{1}\d{8})$/
              if (value && !phonereg.test(value)) {
                return false
              } else {
                return Number(value)
              }
            }
          }
        ],
        expressNo: [
          { required: true, message: "运单号不能为空", trigger: "blur" }
        ],
      },
      executeData: [],
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询出货物流列表 */
    getList() {
      this.loading = true;
      listLogistics(this.queryParams).then(response => {
        this.logisticsList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        inspectId: null,
        express: null,
        username: null,
        tel: null,
        expressNo: null,
        imgUrl: null,
        createTime: null,
        createId: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.getExecuteInfo();
      this.open = true;
      this.title = "添加出货物流";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getLogistics(id).then(response => {
        this.form = response.data;
        this.getExecuteInfo();
        this.open = true;
        this.title = "修改出货物流";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateLogistics(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addLogistics(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除出货物流编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delLogistics(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有出货物流数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportLogistics(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    },
    //获取执行信息
    getExecuteInfo(){
      executeInfoList().then(res =>{
        if(res.code == 200){
          this.executeData = res.data;
        }
      })
    },
    //详情
    handleDetail(row){
      this.$refs.detail.getDetailInfo(row.id);
    },
  }
};
</script>
